#!/usr/bin/perl

$VER = '0.2.0';

## Create CertificateDB - Version $VER
## (c) 1999 by Massimiliano Pala 
## OpenCA Core Team
##
## (OpenCA Project)
##
## Description:
## ============
##
## This program creates a DB of the certificates where the
## ca program will look for certificates. You need to run
## this script BEFORE starting the CA only when you issue
## certificate through the scritps in the bin/ directory and
## not using the Web interface.
##
## The DB structure is very simple, every entry looks like
## the following :
##
##	$serial => $certificate
##
## Please take note that this program, if the DB is not present
## will create it: you must be sure you run it as the user the
## httpd server will run (as the ca program needs to access to
## the DB to properly work). If permissions are not set, please
## change them or rebuild the DB (delete it and use this prog.)
##
## For Any clarifications, please refer to:
##
##	o Documentation;
##	o openca-devel@openca.org;
##


$OPENCA_DIR = $ARGV[0];
print $OPENCA_DIR;

$DB_FILE   = "$OPENCA_DIR/issued_certs";
$STAT_FILE = "$OPENCA_DIR/revoked_certs";

## $DB_FILE   = "$OPENCA_DIR/stuff/issued_certs";
## $STAT_FILE = "$OPENCA_DIR/stuff/revoked_certs";

dbmopen( %CERT_DB, "$DB_FILE", 0600 ) || die "Error: $!";
##	$CERT_DB{0} = "";
dbmclose( %CERT_DB );

dbmopen( %STAT_DB, "$STAT_FILE", 0600 ) || die "Error: $!";
##	$STAT_DB{0} = "";
dbmclose( %STAT_DB );

exit;
