#!/usr/bin/perl

$VER = '0.010a';

## GetCert DB - Version $VER
## (c) 1999 by Massimiliano Pala
## OpenCA Core Developer
##
## (OpenCA Project)
##
## Description:
## ============
##
## This Program let you get a certificate from the DB of the issued
## by your CA ( issued certificates ).

print "\nGetCert DB - Version $VER\n";
print "(c) 1999 by OpenCA Core Team\n\n";
print "Enter The OpenCA dir ( /usr/local/OpenCA ) ? ";
$OPENCA_DIR = <STDIN>;

chop($OPENCA_DIR);

if( "$OPENCA_DIR" eq "" ) {
	$OPENCA_DIR = '/usr/local/OpenCA';
}

print "Enter The Export dir ( $OPENCA_DIR/certs/issued ) ? ";
$EXPORT_DIR = <STDIN>;
chop($EXPORT_DIR);
if( "$EXPORT_DIR" eq "" ) {
	$EXPORT_DIR = "$OPENCA_DIR/certs/issued";
}

print "Enter The Serial Number ? ";
$serial = <STDIN>;
chop($serial);

$EXPORT_ALL=0;

if( not $serial ) {
	print "No serial certificate was given,";
	print " do you want to extract all certs (y/N) ? ";
	$tmp= <STDIN>;
	chop($serial);
	if( ( uc("$tmp") eq "N") or (not $tmp)) {
		print "ok, see you.\n\n";
		exit 0;
	};

	$EXPORT_ALL=1;
}	

$DBM_FILE = "$OPENCA_DIR/stuff/issued_certs";

dbmopen( %CERT_DB, "$DBM_FILE", undef ) || die "Can't access DB!";
	if( $EXPORT_ALL ) {
		while ( ($key, $value) = each  %CERT_DB ) {
			print "Exporting certificate: serial=0x$key, dim=";
			print length($value) ." bytes\n";
			if( ($ret=exportCert($value, $key, $EXPORT_DIR))!= 1 ){
				print "$ret\n\n";
				exit 100;
			}
		}
	}
	else
	{

		$cert = $CERT_DB{$serial};
		if( ! $cert ) {
			print "Error, certificate not present in DB.\n\n";
			exit 101;
		}

		print "Exporting certificate: serial=0x$serial, dim=";
		print length($cert) ." bytes\n";
		if( exportCert( $cert, $serial, $EXPORT_DIR ) != 1 ) {
			print "Error!";
			exit 100;
		}
	}
dbmclose( %CERT_DB );


## Subroutines

sub exportCert {
	my @keys = @_;
	my $cert = $keys[0];
	my $ser  = $keys[1];
	my $dir  = $keys[2];
	
	return "INTERNAL: Wrong parameters passed!"
		 unless ( $cert and  $ser and $dir );

	$fileName = $dir . "/" . $ser . ".pem";
	open( FD, ">$fileName" ) || return "ERROR: Cannot access $fileName!";
		print FD "$cert";
	close( FD );

	return 1;
}
